Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions | Related
kXml Class Reference
kApi/Data

## Description

Represents an XML document.

kXml supports the kObject_Clone method.

kXml supports the kdat6 serialization protocol.

Inheritance diagram for kXml:

## Public Member Functions
kStatus | kXml_AddItem (kXml xml, kXmlItem parent, const kChar *name, kXmlItem *item)
| Inserts a new child node at the end of the specified parent node's child list. More...
kStatus | kXml_Assign (kXml xml, kXml source)
| Copies the source document. More...
kStatus | kXml_Attr16s (kXml xml, kXmlItem item, const kChar *name, k16s *value)
| Gets XML attribute content as a k16s value. More...
kStatus | kXml_Attr16u (kXml xml, kXmlItem item, const kChar *name, k16u *value)
| Gets XML attribute content as a k16u value. More...
kStatus | kXml_Attr32f (kXml xml, kXmlItem item, const kChar *name, k32f *value)
| Gets XML attribute content as a k32f value. More...
kStatus | kXml_Attr32s (kXml xml, kXmlItem item, const kChar *name, k32s *value)
| Gets XML attribute content as a k32s value. More...
kStatus | kXml_Attr32u (kXml xml, kXmlItem item, const kChar *name, k32u *value)
| Gets XML attribute content as a k32u value. More...
kStatus | kXml_Attr64f (kXml xml, kXmlItem item, const kChar *name, k64f *value)
| Gets XML attribute content as a k64f value. More...
kStatus | kXml_Attr64s (kXml xml, kXmlItem item, const kChar *name, k64s *value)
| Gets XML attribute content as a k64s value. More...
kStatus | kXml_Attr64u (kXml xml, kXmlItem item, const kChar *name, k64u *value)
| Gets XML attribute content as a k64u value. More...
kStatus | kXml_AttrBool (kXml xml, kXmlItem item, const kChar *name, kBool *value)
| Gets XML attribute content as a kBool value. More...
kSize | kXml_AttrCount (kXml xml, kXmlItem item)
| Returns the number of attributes for the given XML element. More...
kBool | kXml_AttrExists (kXml xml, kXmlItem item, const kChar *name)
| Reports whether a specific attribute exists for the given XML element. More...
const kChar * | kXml_AttrNameAt (kXml xml, kXmlItem item, kSize index)
| Returns an attribute at a specific index within the list of attributes for the given element node. More...
kStatus | kXml_AttrSize (kXml xml, kXmlItem item, const kChar *name, kSize *value)
| Gets XML attribute content as a kSize value. More...
kStatus | kXml_AttrString (kXml xml, kXmlItem item, const kChar *name, kString string)
| Gets XML attribute content as a string object. More...
kStatus | kXml_AttrText (kXml xml, kXmlItem item, const kChar *name, kChar *str, kSize capacity)
| Gets XML attribute content as a character array. More...
kXmlItem | kXml_Child (kXml xml, kXmlItem parent, const kChar *path)
| Returns the child node at the given relative path. More...
kStatus | kXml_Child16s (kXml xml, kXmlItem parent, const kChar *path, k16s *value)
| Gets XML child node content as a k16s value. More...
kStatus | kXml_Child16u (kXml xml, kXmlItem parent, const kChar *path, k16u *value)
| Gets XML child node content as a k16u value. More...
kStatus | kXml_Child32f (kXml xml, kXmlItem parent, const kChar *path, k32f *value)
| Gets XML child node content as a k32f value. More...
kStatus | kXml_Child32s (kXml xml, kXmlItem parent, const kChar *path, k32s *value)
| Gets XML child node content as a k32s value. More...
kStatus | kXml_Child32u (kXml xml, kXmlItem parent, const kChar *path, k32u *value)
| Gets XML child node content as a k32u value. More...
kStatus | kXml_Child64f (kXml xml, kXmlItem parent, const kChar *path, k64f *value)
| Gets XML child node content as a k64f value. More...
kStatus | kXml_Child64s (kXml xml, kXmlItem parent, const kChar *path, k64s *value)
| Gets XML child node content as a k64s value. More...
kStatus | kXml_Child64u (kXml xml, kXmlItem parent, const kChar *path, k64u *value)
| Gets XML child node content as a k64u value. More...
kXmlItem | kXml_ChildAt (kXml xml, kXmlItem parent, kSize index)
| Returns a child node at a specific index within the list of child nodes for the given parent node. More...
kStatus | kXml_ChildBool (kXml xml, kXmlItem parent, const kChar *path, kBool *value)
| Gets XML child node content as a kBool value. More...
kSize | kXml_ChildCount (kXml xml, kXmlItem parent)
| Returns the number of child nodes for the given parent node. More...
kBool | kXml_ChildExists (kXml xml, kXmlItem parent, const kChar *path)
| Reports whether a child node exists at the specified relative path. More...
kStatus | kXml_ChildSize (kXml xml, kXmlItem parent, const kChar *path, kSize *value)
| Gets XML child node content as a kSize value. More...
kStatus | kXml_ChildString (kXml xml, kXmlItem parent, const kChar *path, kString str)
| Gets XML child node content as a string object. More...
kStatus | kXml_ChildText (kXml xml, kXmlItem parent, const kChar *path, kChar *str, kSize capacity)
| Gets XML child node content as a character array. More...
kStatus | kXml_Clear (kXml xml)
| Removes all elements from the XML document. More...
kStatus | kXml_ClearItem (kXml xml, kXmlItem item)
| Removes all children, attributes, and value from the XML element node. More...
kStatus | kXml_Compact (kXml xml)
| Compacts the XML object for minimum memory usage. More...
kStatus | kXml_Construct (kXml *xml, kAlloc allocator)
| Constructs a kXml object. More...
kStatus | kXml_CopyItem (kXml xml, kXmlItem parent, kXmlItem before, kXml srcXml, kXmlItem srcItem, kXmlItem *item)
| Copies a node from another XML document to this document, inserting a new node at the specified location. More...
kStatus | kXml_DeleteAttr (kXml xml, kXmlItem item, const kChar *name)
| Deletes an XML attribute. More...
kStatus | kXml_DeleteAttrs (kXml xml, kXmlItem item)
| Deletes all XML attributes. More...
kStatus | kXml_DeleteChildren (kXml xml, kXmlItem item)
| Deletes all children in the specified parent item. More...
kStatus | kXml_DeleteItem (kXml xml, kXmlItem item)
| Deletes an XML element node. More...
kStatus | kXml_EnsureChildExists (kXml xml, kXmlItem parent, const kChar *path, kXmlItem *item)
| Ensures that a child node exists at the specified path. More...
kStatus | kXml_FindChild (kXml xml, kXmlItem parent, const kChar *path, kXmlItem *child)
| Finds the child node at the given relative path, if it exists. More...
kStatus | kXml_FindRoot (kXml xml, kXmlItem *root)
| Finds the root node, if it exists. More...
kXmlItem | kXml_FirstChild (kXml xml, kXmlItem parent)
| Returns the first child element of the given parent node. More...
kStatus | kXml_FromString (kXml xml, kString str)
| Loads an XML document from a string object. More...
kStatus | kXml_FromText (kXml *xml, const kChar *str, kAlloc allocator)
| Loads an XML document from a character array. More...
kStatus | kXml_InsertItem (kXml xml, kXmlItem before, const kChar *name, kXmlItem *item)
| Inserts a new node before the specified sibling node. More...
kStatus | kXml_Item16s (kXml xml, kXmlItem item, k16s *value)
| Gets XML element node content as a k16s value. More...
kStatus | kXml_Item16u (kXml xml, kXmlItem item, k16u *value)
| Gets XML element node content as a k16u value. More...
kStatus | kXml_Item32f (kXml xml, kXmlItem item, k32f *value)
| Gets XML element node content as a k32f value. More...
kStatus | kXml_Item32s (kXml xml, kXmlItem item, k32s *value)
| Gets XML element node content as a k32s value. More...
kStatus | kXml_Item32u (kXml xml, kXmlItem item, k32u *value)
| Gets XML element node content as a k32u value. More...
kStatus | kXml_Item64f (kXml xml, kXmlItem item, k64f *value)
| Gets XML element node content as a k64f value. More...
kStatus | kXml_Item64s (kXml xml, kXmlItem item, k64s *value)
| Gets XML element node content as a k64s value. More...
kStatus | kXml_Item64u (kXml xml, kXmlItem item, k64u *value)
| Gets XML element node content as a k64u value. More...
kStatus | kXml_ItemBool (kXml xml, kXmlItem item, kBool *value)
| Gets XML element node content as a kBool value. More...
const kChar * | kXml_ItemName (kXml xml, kXmlItem item)
| Returns the name of an XML element node. More...
kStatus | kXml_ItemSize (kXml xml, kXmlItem item, kSize *value)
| Gets XML element node content as a kSize value. More...
kStatus | kXml_ItemString (kXml xml, kXmlItem item, kString str)
| Gets XML element node content as a string object. More...
kStatus | kXml_ItemText (kXml xml, kXmlItem item, kChar *str, kSize capacity)
| Gets XML element content as a character array. More...
kXmlItem | kXml_LastChild (kXml xml, kXmlItem parent)
| Returns the last child element of the given parent node. More...
kStatus | kXml_Load (kXml *xml, const kChar *fileName, kAlloc allocator)
| Loads an XML document from file. More...
kStatus | kXml_LoadBytes (kXml *xml, const kByte *data, kSize size, kAlloc allocator)
| Loads an XML document from an in-memory file. More...
kXmlItem | kXml_NextSibling (kXml xml, kXmlItem item)
| Returns the next sibling element of the given element node. More...
kStatus | kXml_OverwriteItem (kXml xml, kXmlItem destItem, kXml srcXml, kXmlItem srcItem)
| Copies a node from another XML document to this document, overwriting an existing element. More...
kXmlItem | kXml_Parent (kXml xml, kXmlItem item)
| Returns the parent node of the given element. More...
kXmlItem | kXml_PreviousSibling (kXml xml, kXmlItem item)
| Returns the previous sibling element of the given element node. More...
kStatus | kXml_Read (kXml xml, kStream stream)
| Loads an XML document from a stream. More...
kXmlItem | kXml_Root (kXml xml)
| Returns the root element of the XML document. More...
kStatus | kXml_Save (kXml xml, const kChar *fileName)
| Saves the XML document object to file. More...
kStatus | kXml_SaveBytes (kXml xml, kByte **data, kSize *size, kAlloc allocator)
| Saves an XML document to an in-memory file. More...
kStatus | kXml_SetAttr16s (kXml xml, kXmlItem item, const kChar *name, k16s value)
| Sets XML attribute content from a k16s value. More...
kStatus | kXml_SetAttr16u (kXml xml, kXmlItem item, const kChar *name, k16u value)
| Sets XML attribute content from a k16u value. More...
kStatus | kXml_SetAttr32f (kXml xml, kXmlItem item, const kChar *name, k32f value)
| Sets XML attribute content from a k32f value. More...
kStatus | kXml_SetAttr32s (kXml xml, kXmlItem item, const kChar *name, k32s value)
| Sets XML attribute content from a k32s value. More...
kStatus | kXml_SetAttr32u (kXml xml, kXmlItem item, const kChar *name, k32u value)
| Sets XML attribute content from a k32u value. More...
kStatus | kXml_SetAttr64f (kXml xml, kXmlItem item, const kChar *name, k64f value)
| Sets XML attribute content from a k64f value. More...
kStatus | kXml_SetAttr64s (kXml xml, kXmlItem item, const kChar *name, k64s value)
| Sets XML attribute content from a k64s value. More...
kStatus | kXml_SetAttr64u (kXml xml, kXmlItem item, const kChar *name, k64u value)
| Sets XML attribute content from a k64u value. More...
kStatus | kXml_SetAttrBool (kXml xml, kXmlItem item, const kChar *name, kBool value)
| Sets XML attribute content from a kBool value. More...
kStatus | kXml_SetAttrSize (kXml xml, kXmlItem item, const kChar *name, kSize value)
| Sets XML attribute content from a kSize value. More...
kStatus | kXml_SetAttrText (kXml xml, kXmlItem item, const kChar *name, const kChar *str)
| Sets XML attribute content from a character array. More...
kStatus | kXml_SetChild16s (kXml xml, kXmlItem parent, const kChar *path, k16s value)
| Sets XML child node content from a k16s value. More...
kStatus | kXml_SetChild16u (kXml xml, kXmlItem parent, const kChar *path, k16u value)
| Sets XML child node content from a k16u value. More...
kStatus | kXml_SetChild32f (kXml xml, kXmlItem parent, const kChar *path, k32f value)
| Sets XML child node content from a k32f value. More...
kStatus | kXml_SetChild32s (kXml xml, kXmlItem parent, const kChar *path, k32s value)
| Sets XML child node content from a k32s value. More...
kStatus | kXml_SetChild32u (kXml xml, kXmlItem parent, const kChar *path, k32u value)
| Sets XML child node content from a k32u value. More...
kStatus | kXml_SetChild64f (kXml xml, kXmlItem parent, const kChar *path, k64f value)
| Sets XML child node content from a k64f value. More...
kStatus | kXml_SetChild64s (kXml xml, kXmlItem parent, const kChar *path, k64s value)
| Sets XML child node content from a k64s value. More...
kStatus | kXml_SetChild64u (kXml xml, kXmlItem parent, const kChar *path, k64u value)
| Sets XML child node content from a k64u value. More...
kStatus | kXml_SetChildBool (kXml xml, kXmlItem parent, const kChar *path, kBool value)
| Sets XML child node content from a kBool value. More...
kStatus | kXml_SetChildSize (kXml xml, kXmlItem parent, const kChar *path, kSize value)
| Sets XML child node content from a kSize value. More...
kStatus | kXml_SetChildText (kXml xml, kXmlItem parent, const kChar *path, const kChar *str)
| Sets XML child node content from a character array. More...
kStatus | kXml_SetItem16s (kXml xml, kXmlItem item, k16s value)
| Sets XML element node content from a k16s value. More...
kStatus | kXml_SetItem16u (kXml xml, kXmlItem item, k16u value)
| Sets XML element node content from a k16u value. More...
kStatus | kXml_SetItem32f (kXml xml, kXmlItem item, k32f value)
| Sets XML element node content from a k32f value. More...
kStatus | kXml_SetItem32s (kXml xml, kXmlItem item, k32s value)
| Sets XML element node content from a k32s value. More...
kStatus | kXml_SetItem32u (kXml xml, kXmlItem item, k32u value)
| Sets XML element node content from a k32u value. More...
kStatus | kXml_SetItem64f (kXml xml, kXmlItem item, k64f value)
| Sets XML element node content from a k64f value. More...
kStatus | kXml_SetItem64s (kXml xml, kXmlItem item, k64s value)
| Sets XML element node content from a k64s value. More...
kStatus | kXml_SetItem64u (kXml xml, kXmlItem item, k64u value)
| Sets XML element node content from a k64u value. More...
kStatus | kXml_SetItemBool (kXml xml, kXmlItem item, kBool value)
| Sets XML element node content from a kBool value. More...
kStatus | kXml_SetItemName (kXml xml, kXmlItem item, const kChar *name)
| Sets the name of an XML element node. More...
kStatus | kXml_SetItemSize (kXml xml, kXmlItem item, kSize value)
| Sets XML element node content from a kSize value. More...
kStatus | kXml_SetItemText (kXml xml, kXmlItem item, const kChar *str)
| Sets XML element node content from a character array. More...
kStatus | kXml_ToString (kXml xml, kString str)
| Exports the XML document to a string object. More...
kStatus | kXml_Write (kXml xml, kStream stream)
| Writes an XML document to a stream. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kBool | kObject_HasForeignData (kObject object)
| Reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...

## Related
kPointer | kXmlItem
| Represents an XML element within an XML document.

## Additional Inherited Members
Protected Member Functions inherited from kObject
kStatus | kObject_FreeMem (kObject object, void *mem)
| Protected method called by derived classes to free memory using the object's allocator. More...
kStatus | kObject_FreeMemRef (kObject object, void *mem)
| Protected method called by derived classes to free memory (and reset the provided memory pointer to kNULL) using the object's allocator. More...
kStatus | kObject_GetMem (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate memory using the object's allocator. More...
kStatus | kObject_GetMemZero (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate and zero memory using the object's allocator. More...
kStatus | kObject_Init (kObject object, kType type, kAlloc alloc)
| Protected method called by derived classes to initialize the kObject base class. More...
kStatus | kObject_VDisposeItems (kObject object)
| Protected virtual method that destroys any aggregated child objects associated with a collection. More...
kBool | kObject_VEquals (kObject object, kObject other)
| Protected virtual method that compares two objects for equality. More...
kBool | kObject_VHasForeignData (kObject object)
| Protected virtual method that reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_VHashCode (kObject object)
| Protected virtual method that calculates a hash code representing the object instance. More...
kStatus | kObject_VInitClone (kObject object, kObject source, kAlloc allocator)
| Protected virtual method that clones (makes a deep copy of) the specified source object. More...
kStatus | kObject_VRelease (kObject object)
| Protected virtual method that deallocates any resources owned by the object. More...
kSize | kObject_VSize (kObject object)
| Protected virtual method that calculates the total size (in bytes) of the object instance. More...

The documentation for this class was generated from the following file:

- Data/kXml.h